function y = equations(mu) 
%% function automatically generated by worm_sim 
%% notation: 
%% mu(i,j,k)     service rate of k-th input channel at router (i,j)
%% ro(i,j,k)     utilization of k-th input channel at router (i,j)
%% lambda(i,j,k)  load of k-th input channel at router (i,j)
%% mu_eff(i,j,k) effective service rate of k-th input channel at (i,j)
%%               as observed by its upstream input channel buffers
%% mu_tmp(i,j,k) service rate of k-th input channel without taking into
%%               consideration the channel's physical service rate
%% b(i,j,k)      buffer depth (in flits) for k-th input channel at (i,j)



%% once you get the mu of each channel, you can estimate the latency indication
%% by calculating sum(lambda(i,j,k) / (mu(i,j,k) - lambda(i,j,k))).
%% This value gives you an indication of the packet latency, and the real
%% estimated value should be devided by the sum of all the packets injection
%% rate.

%% buffer depth will be passed from external scripts as global variables
global b;

%% lambda variable will also be used by external scripts, so make it global
global lambda;

%% lambda (load) values: 
lambda(1,1,1) = 0.133;
lambda(1,1,2) = 0.114158;
lambda(1,1,3) = 0;
lambda(1,1,4) = 0.0953167;
lambda(1,1,5) = 0;
lambda(1,2,1) = 0.133;
lambda(1,2,2) = 0.155167;
lambda(1,2,3) = 0.1197;
lambda(1,2,4) = 0.117483;
lambda(1,2,5) = 0;
lambda(1,3,1) = 0.133;
lambda(1,3,2) = 0.1197;
lambda(1,3,3) = 0.155167;
lambda(1,3,4) = 0.117483;
lambda(1,3,5) = 0;
lambda(1,4,1) = 0.133;
lambda(1,4,2) = 0;
lambda(1,4,3) = 0.114158;
lambda(1,4,4) = 0.0953167;
lambda(1,4,5) = 0;
lambda(2,1,1) = 0.133;
lambda(2,1,2) = 0.142421;
lambda(2,1,3) = 0;
lambda(2,1,4) = 0.1197;
lambda(2,1,5) = 0.089775;
lambda(2,2,1) = 0.133;
lambda(2,2,2) = 0.181767;
lambda(2,2,3) = 0.12635;
lambda(2,2,4) = 0.164033;
lambda(2,2,5) = 0.123025;
lambda(2,3,1) = 0.133;
lambda(2,3,2) = 0.12635;
lambda(2,3,3) = 0.181767;
lambda(2,3,4) = 0.164033;
lambda(2,3,5) = 0.123025;
lambda(2,4,1) = 0.133;
lambda(2,4,2) = 0;
lambda(2,4,3) = 0.142421;
lambda(2,4,4) = 0.1197;
lambda(2,4,5) = 0.089775;
lambda(3,1,1) = 0.133;
lambda(3,1,2) = 0.0919917;
lambda(3,1,3) = 0;
lambda(3,1,4) = 0.1064;
lambda(3,1,5) = 0.130229;
lambda(3,2,1) = 0.133;
lambda(3,2,2) = 0.137433;
lambda(3,2,3) = 0.1197;
lambda(3,2,4) = 0.1064;
lambda(3,2,5) = 0.153504;
lambda(3,3,1) = 0.133;
lambda(3,3,2) = 0.1197;
lambda(3,3,3) = 0.137433;
lambda(3,3,4) = 0.1064;
lambda(3,3,5) = 0.153504;
lambda(3,4,1) = 0.133;
lambda(3,4,2) = 0;
lambda(3,4,3) = 0.0919917;
lambda(3,4,4) = 0.1064;
lambda(3,4,5) = 0.130229;
lambda(4,1,1) = 0.133;
lambda(4,1,2) = 0.0770292;
lambda(4,1,3) = 0;
lambda(4,1,4) = 0;
lambda(4,1,5) = 0.0892208;
lambda(4,2,1) = 0.133;
lambda(4,2,2) = 0.0931;
lambda(4,2,3) = 0.05985;
lambda(4,2,4) = 0;
lambda(4,2,5) = 0.123579;
lambda(4,3,1) = 0.133;
lambda(4,3,2) = 0.05985;
lambda(4,3,3) = 0.0931;
lambda(4,3,4) = 0;
lambda(4,3,5) = 0.123579;
lambda(4,4,1) = 0.133;
lambda(4,4,2) = 0;
lambda(4,4,3) = 0.0770292;
lambda(4,4,4) = 0;
lambda(4,4,5) = 0.0892208;


%% ro value calculation: 
ro(1,1,1) = lambda(1,1,1) / mu(1,1,1);
ro(1,1,2) = lambda(1,1,2) / mu(1,1,2);
ro(1,1,3) = 0;
ro(1,1,4) = lambda(1,1,4) / mu(1,1,4);
ro(1,1,5) = 0;
ro(1,2,1) = lambda(1,2,1) / mu(1,2,1);
ro(1,2,2) = lambda(1,2,2) / mu(1,2,2);
ro(1,2,3) = lambda(1,2,3) / mu(1,2,3);
ro(1,2,4) = lambda(1,2,4) / mu(1,2,4);
ro(1,2,5) = 0;
ro(1,3,1) = lambda(1,3,1) / mu(1,3,1);
ro(1,3,2) = lambda(1,3,2) / mu(1,3,2);
ro(1,3,3) = lambda(1,3,3) / mu(1,3,3);
ro(1,3,4) = lambda(1,3,4) / mu(1,3,4);
ro(1,3,5) = 0;
ro(1,4,1) = lambda(1,4,1) / mu(1,4,1);
ro(1,4,2) = 0;
ro(1,4,3) = lambda(1,4,3) / mu(1,4,3);
ro(1,4,4) = lambda(1,4,4) / mu(1,4,4);
ro(1,4,5) = 0;
ro(2,1,1) = lambda(2,1,1) / mu(2,1,1);
ro(2,1,2) = lambda(2,1,2) / mu(2,1,2);
ro(2,1,3) = 0;
ro(2,1,4) = lambda(2,1,4) / mu(2,1,4);
ro(2,1,5) = lambda(2,1,5) / mu(2,1,5);
ro(2,2,1) = lambda(2,2,1) / mu(2,2,1);
ro(2,2,2) = lambda(2,2,2) / mu(2,2,2);
ro(2,2,3) = lambda(2,2,3) / mu(2,2,3);
ro(2,2,4) = lambda(2,2,4) / mu(2,2,4);
ro(2,2,5) = lambda(2,2,5) / mu(2,2,5);
ro(2,3,1) = lambda(2,3,1) / mu(2,3,1);
ro(2,3,2) = lambda(2,3,2) / mu(2,3,2);
ro(2,3,3) = lambda(2,3,3) / mu(2,3,3);
ro(2,3,4) = lambda(2,3,4) / mu(2,3,4);
ro(2,3,5) = lambda(2,3,5) / mu(2,3,5);
ro(2,4,1) = lambda(2,4,1) / mu(2,4,1);
ro(2,4,2) = 0;
ro(2,4,3) = lambda(2,4,3) / mu(2,4,3);
ro(2,4,4) = lambda(2,4,4) / mu(2,4,4);
ro(2,4,5) = lambda(2,4,5) / mu(2,4,5);
ro(3,1,1) = lambda(3,1,1) / mu(3,1,1);
ro(3,1,2) = lambda(3,1,2) / mu(3,1,2);
ro(3,1,3) = 0;
ro(3,1,4) = lambda(3,1,4) / mu(3,1,4);
ro(3,1,5) = lambda(3,1,5) / mu(3,1,5);
ro(3,2,1) = lambda(3,2,1) / mu(3,2,1);
ro(3,2,2) = lambda(3,2,2) / mu(3,2,2);
ro(3,2,3) = lambda(3,2,3) / mu(3,2,3);
ro(3,2,4) = lambda(3,2,4) / mu(3,2,4);
ro(3,2,5) = lambda(3,2,5) / mu(3,2,5);
ro(3,3,1) = lambda(3,3,1) / mu(3,3,1);
ro(3,3,2) = lambda(3,3,2) / mu(3,3,2);
ro(3,3,3) = lambda(3,3,3) / mu(3,3,3);
ro(3,3,4) = lambda(3,3,4) / mu(3,3,4);
ro(3,3,5) = lambda(3,3,5) / mu(3,3,5);
ro(3,4,1) = lambda(3,4,1) / mu(3,4,1);
ro(3,4,2) = 0;
ro(3,4,3) = lambda(3,4,3) / mu(3,4,3);
ro(3,4,4) = lambda(3,4,4) / mu(3,4,4);
ro(3,4,5) = lambda(3,4,5) / mu(3,4,5);
ro(4,1,1) = lambda(4,1,1) / mu(4,1,1);
ro(4,1,2) = lambda(4,1,2) / mu(4,1,2);
ro(4,1,3) = 0;
ro(4,1,4) = 0;
ro(4,1,5) = lambda(4,1,5) / mu(4,1,5);
ro(4,2,1) = lambda(4,2,1) / mu(4,2,1);
ro(4,2,2) = lambda(4,2,2) / mu(4,2,2);
ro(4,2,3) = lambda(4,2,3) / mu(4,2,3);
ro(4,2,4) = 0;
ro(4,2,5) = lambda(4,2,5) / mu(4,2,5);
ro(4,3,1) = lambda(4,3,1) / mu(4,3,1);
ro(4,3,2) = lambda(4,3,2) / mu(4,3,2);
ro(4,3,3) = lambda(4,3,3) / mu(4,3,3);
ro(4,3,4) = 0;
ro(4,3,5) = lambda(4,3,5) / mu(4,3,5);
ro(4,4,1) = lambda(4,4,1) / mu(4,4,1);
ro(4,4,2) = 0;
ro(4,4,3) = lambda(4,4,3) / mu(4,4,3);
ro(4,4,4) = 0;
ro(4,4,5) = lambda(4,4,5) / mu(4,4,5);


%% mu_eff (effective service rate seen by upstream input buffers) calculation: 
mu_eff(1,1,1) = 1;
mu_eff(1,1,2) = (1 - ro(1,1,2) ^ b(1,1,2)) / (1 - ro(1,1,2) ^ (b(1,1,2) + 1));
mu_eff(1,1,3) = (1 - ro(1,1,3) ^ b(1,1,3)) / (1 - ro(1,1,3) ^ (b(1,1,3) + 1));
mu_eff(1,1,4) = (1 - ro(1,1,4) ^ b(1,1,4)) / (1 - ro(1,1,4) ^ (b(1,1,4) + 1));
mu_eff(1,1,5) = (1 - ro(1,1,5) ^ b(1,1,5)) / (1 - ro(1,1,5) ^ (b(1,1,5) + 1));
mu_eff(1,2,1) = 1;
mu_eff(1,2,2) = (1 - ro(1,2,2) ^ b(1,2,2)) / (1 - ro(1,2,2) ^ (b(1,2,2) + 1));
mu_eff(1,2,3) = (1 - ro(1,2,3) ^ b(1,2,3)) / (1 - ro(1,2,3) ^ (b(1,2,3) + 1));
mu_eff(1,2,4) = (1 - ro(1,2,4) ^ b(1,2,4)) / (1 - ro(1,2,4) ^ (b(1,2,4) + 1));
mu_eff(1,2,5) = (1 - ro(1,2,5) ^ b(1,2,5)) / (1 - ro(1,2,5) ^ (b(1,2,5) + 1));
mu_eff(1,3,1) = 1;
mu_eff(1,3,2) = (1 - ro(1,3,2) ^ b(1,3,2)) / (1 - ro(1,3,2) ^ (b(1,3,2) + 1));
mu_eff(1,3,3) = (1 - ro(1,3,3) ^ b(1,3,3)) / (1 - ro(1,3,3) ^ (b(1,3,3) + 1));
mu_eff(1,3,4) = (1 - ro(1,3,4) ^ b(1,3,4)) / (1 - ro(1,3,4) ^ (b(1,3,4) + 1));
mu_eff(1,3,5) = (1 - ro(1,3,5) ^ b(1,3,5)) / (1 - ro(1,3,5) ^ (b(1,3,5) + 1));
mu_eff(1,4,1) = 1;
mu_eff(1,4,2) = (1 - ro(1,4,2) ^ b(1,4,2)) / (1 - ro(1,4,2) ^ (b(1,4,2) + 1));
mu_eff(1,4,3) = (1 - ro(1,4,3) ^ b(1,4,3)) / (1 - ro(1,4,3) ^ (b(1,4,3) + 1));
mu_eff(1,4,4) = (1 - ro(1,4,4) ^ b(1,4,4)) / (1 - ro(1,4,4) ^ (b(1,4,4) + 1));
mu_eff(1,4,5) = (1 - ro(1,4,5) ^ b(1,4,5)) / (1 - ro(1,4,5) ^ (b(1,4,5) + 1));
mu_eff(2,1,1) = 1;
mu_eff(2,1,2) = (1 - ro(2,1,2) ^ b(2,1,2)) / (1 - ro(2,1,2) ^ (b(2,1,2) + 1));
mu_eff(2,1,3) = (1 - ro(2,1,3) ^ b(2,1,3)) / (1 - ro(2,1,3) ^ (b(2,1,3) + 1));
mu_eff(2,1,4) = (1 - ro(2,1,4) ^ b(2,1,4)) / (1 - ro(2,1,4) ^ (b(2,1,4) + 1));
mu_eff(2,1,5) = (1 - ro(2,1,5) ^ b(2,1,5)) / (1 - ro(2,1,5) ^ (b(2,1,5) + 1));
mu_eff(2,2,1) = 1;
mu_eff(2,2,2) = (1 - ro(2,2,2) ^ b(2,2,2)) / (1 - ro(2,2,2) ^ (b(2,2,2) + 1));
mu_eff(2,2,3) = (1 - ro(2,2,3) ^ b(2,2,3)) / (1 - ro(2,2,3) ^ (b(2,2,3) + 1));
mu_eff(2,2,4) = (1 - ro(2,2,4) ^ b(2,2,4)) / (1 - ro(2,2,4) ^ (b(2,2,4) + 1));
mu_eff(2,2,5) = (1 - ro(2,2,5) ^ b(2,2,5)) / (1 - ro(2,2,5) ^ (b(2,2,5) + 1));
mu_eff(2,3,1) = 1;
mu_eff(2,3,2) = (1 - ro(2,3,2) ^ b(2,3,2)) / (1 - ro(2,3,2) ^ (b(2,3,2) + 1));
mu_eff(2,3,3) = (1 - ro(2,3,3) ^ b(2,3,3)) / (1 - ro(2,3,3) ^ (b(2,3,3) + 1));
mu_eff(2,3,4) = (1 - ro(2,3,4) ^ b(2,3,4)) / (1 - ro(2,3,4) ^ (b(2,3,4) + 1));
mu_eff(2,3,5) = (1 - ro(2,3,5) ^ b(2,3,5)) / (1 - ro(2,3,5) ^ (b(2,3,5) + 1));
mu_eff(2,4,1) = 1;
mu_eff(2,4,2) = (1 - ro(2,4,2) ^ b(2,4,2)) / (1 - ro(2,4,2) ^ (b(2,4,2) + 1));
mu_eff(2,4,3) = (1 - ro(2,4,3) ^ b(2,4,3)) / (1 - ro(2,4,3) ^ (b(2,4,3) + 1));
mu_eff(2,4,4) = (1 - ro(2,4,4) ^ b(2,4,4)) / (1 - ro(2,4,4) ^ (b(2,4,4) + 1));
mu_eff(2,4,5) = (1 - ro(2,4,5) ^ b(2,4,5)) / (1 - ro(2,4,5) ^ (b(2,4,5) + 1));
mu_eff(3,1,1) = 1;
mu_eff(3,1,2) = (1 - ro(3,1,2) ^ b(3,1,2)) / (1 - ro(3,1,2) ^ (b(3,1,2) + 1));
mu_eff(3,1,3) = (1 - ro(3,1,3) ^ b(3,1,3)) / (1 - ro(3,1,3) ^ (b(3,1,3) + 1));
mu_eff(3,1,4) = (1 - ro(3,1,4) ^ b(3,1,4)) / (1 - ro(3,1,4) ^ (b(3,1,4) + 1));
mu_eff(3,1,5) = (1 - ro(3,1,5) ^ b(3,1,5)) / (1 - ro(3,1,5) ^ (b(3,1,5) + 1));
mu_eff(3,2,1) = 1;
mu_eff(3,2,2) = (1 - ro(3,2,2) ^ b(3,2,2)) / (1 - ro(3,2,2) ^ (b(3,2,2) + 1));
mu_eff(3,2,3) = (1 - ro(3,2,3) ^ b(3,2,3)) / (1 - ro(3,2,3) ^ (b(3,2,3) + 1));
mu_eff(3,2,4) = (1 - ro(3,2,4) ^ b(3,2,4)) / (1 - ro(3,2,4) ^ (b(3,2,4) + 1));
mu_eff(3,2,5) = (1 - ro(3,2,5) ^ b(3,2,5)) / (1 - ro(3,2,5) ^ (b(3,2,5) + 1));
mu_eff(3,3,1) = 1;
mu_eff(3,3,2) = (1 - ro(3,3,2) ^ b(3,3,2)) / (1 - ro(3,3,2) ^ (b(3,3,2) + 1));
mu_eff(3,3,3) = (1 - ro(3,3,3) ^ b(3,3,3)) / (1 - ro(3,3,3) ^ (b(3,3,3) + 1));
mu_eff(3,3,4) = (1 - ro(3,3,4) ^ b(3,3,4)) / (1 - ro(3,3,4) ^ (b(3,3,4) + 1));
mu_eff(3,3,5) = (1 - ro(3,3,5) ^ b(3,3,5)) / (1 - ro(3,3,5) ^ (b(3,3,5) + 1));
mu_eff(3,4,1) = 1;
mu_eff(3,4,2) = (1 - ro(3,4,2) ^ b(3,4,2)) / (1 - ro(3,4,2) ^ (b(3,4,2) + 1));
mu_eff(3,4,3) = (1 - ro(3,4,3) ^ b(3,4,3)) / (1 - ro(3,4,3) ^ (b(3,4,3) + 1));
mu_eff(3,4,4) = (1 - ro(3,4,4) ^ b(3,4,4)) / (1 - ro(3,4,4) ^ (b(3,4,4) + 1));
mu_eff(3,4,5) = (1 - ro(3,4,5) ^ b(3,4,5)) / (1 - ro(3,4,5) ^ (b(3,4,5) + 1));
mu_eff(4,1,1) = 1;
mu_eff(4,1,2) = (1 - ro(4,1,2) ^ b(4,1,2)) / (1 - ro(4,1,2) ^ (b(4,1,2) + 1));
mu_eff(4,1,3) = (1 - ro(4,1,3) ^ b(4,1,3)) / (1 - ro(4,1,3) ^ (b(4,1,3) + 1));
mu_eff(4,1,4) = (1 - ro(4,1,4) ^ b(4,1,4)) / (1 - ro(4,1,4) ^ (b(4,1,4) + 1));
mu_eff(4,1,5) = (1 - ro(4,1,5) ^ b(4,1,5)) / (1 - ro(4,1,5) ^ (b(4,1,5) + 1));
mu_eff(4,2,1) = 1;
mu_eff(4,2,2) = (1 - ro(4,2,2) ^ b(4,2,2)) / (1 - ro(4,2,2) ^ (b(4,2,2) + 1));
mu_eff(4,2,3) = (1 - ro(4,2,3) ^ b(4,2,3)) / (1 - ro(4,2,3) ^ (b(4,2,3) + 1));
mu_eff(4,2,4) = (1 - ro(4,2,4) ^ b(4,2,4)) / (1 - ro(4,2,4) ^ (b(4,2,4) + 1));
mu_eff(4,2,5) = (1 - ro(4,2,5) ^ b(4,2,5)) / (1 - ro(4,2,5) ^ (b(4,2,5) + 1));
mu_eff(4,3,1) = 1;
mu_eff(4,3,2) = (1 - ro(4,3,2) ^ b(4,3,2)) / (1 - ro(4,3,2) ^ (b(4,3,2) + 1));
mu_eff(4,3,3) = (1 - ro(4,3,3) ^ b(4,3,3)) / (1 - ro(4,3,3) ^ (b(4,3,3) + 1));
mu_eff(4,3,4) = (1 - ro(4,3,4) ^ b(4,3,4)) / (1 - ro(4,3,4) ^ (b(4,3,4) + 1));
mu_eff(4,3,5) = (1 - ro(4,3,5) ^ b(4,3,5)) / (1 - ro(4,3,5) ^ (b(4,3,5) + 1));
mu_eff(4,4,1) = 1;
mu_eff(4,4,2) = (1 - ro(4,4,2) ^ b(4,4,2)) / (1 - ro(4,4,2) ^ (b(4,4,2) + 1));
mu_eff(4,4,3) = (1 - ro(4,4,3) ^ b(4,4,3)) / (1 - ro(4,4,3) ^ (b(4,4,3) + 1));
mu_eff(4,4,4) = (1 - ro(4,4,4) ^ b(4,4,4)) / (1 - ro(4,4,4) ^ (b(4,4,4) + 1));
mu_eff(4,4,5) = (1 - ro(4,4,5) ^ b(4,4,5)) / (1 - ro(4,4,5) ^ (b(4,4,5) + 1));


%% equations describing mu_eff and mu_tmp: 
